@mixin border_radius($radius) {
    border-radius: $radius;
    -moz-border-radius: $radius;
    -webkit-border-radius: $radius;
    -o-border-radius: $radius;
}

@mixin transition_duration($duration:0s) {
    -o-transition: $duration;
    -ms-transition: $duration;
    -moz-transition: $duration;
    -webkit-transition: $duration;
    transition: $duration;
}

@mixin linear_gradient($top, $bottom){
    background: $top; /* Old browsers */
    background: -moz-linear-gradient(top,  $top 0%, $bottom 100%);
    background: -webkit-gradient(linear, left top, left bottom, color-stop(0%,$top), color-stop(100%,$bottom)); /* Chrome,Safari4+ */
    background: -webkit-linear-gradient(top,  $top 0%,$bottom 100%);
    background: -o-linear-gradient(top,  $top 0%,$bottom 100%);
    background: -ms-linear-gradient(top,  $top 0%,$bottom 100%);
    background: linear-gradient(to bottom,  $top 0%,$bottom 100%);
}

@mixin diagonal_gradient($color1, $color2){
    background: $color1;
    background: -moz-linear-gradient(-45deg, $color1 0%, $color2 100%);
    background: -webkit-linear-gradient(-45deg, $color1 0%,$color2 100%);
    background: linear-gradient(135deg, $color1 0%,$color2 100%);
}

@mixin horizontal-gradient($from, $to, $stop: 100%) {
    background-color: $from;
    background-image: -moz-linear-gradient(left, $from 0%, $to $stop);
    background-image: -webkit-gradient(linear, left top, right top, color-stop(0%, $from), color-stop($stop, $to));
    background-image: -webkit-linear-gradient(left, $from 0%, $to $stop);
    background-image: -o-linear-gradient(left, $from 0%, $to $stop);
    background: -ms-linear-gradient(left, $from 0%, $to $stop);
    background: linear-gradient(to right, $from 0%, $to $stop);
    filter: progid:DXImageTransform.Microsoft.gradient( startColorstr='$from', endColorstr='$to',GradientType=1 );
  }

@mixin opacity($opacity) {
  opacity: $opacity;
  $opacity-ie: $opacity * 100;
  filter: alpha(opacity=$opacity-ie); //IE8
}

@mixin horizontal_scroll {
    white-space: nowrap; 
    overflow-x: auto; 
    -webkit-overflow-scrolling: touch; 
    -ms-overflow-style: -ms-autohiding-scrollbar;
}

@mixin box_shadow($shadow_color) {
    -moz-box-shadow: 0 4px 20px -8px $shadow_color;
    -webkit-box-shadow: 0 4px 20px -8px $shadow_color;
    box-shadow: 0 4px 20px -8px $shadow_color;
}

@mixin grayscale_element($value) {
    -webkit-filter: #{"grayscale(#{$value})"};
    -moz-filter: #{"grayscale(#{$value})"};
    filter:#{"grayscale(#{$value})"};
}

@mixin flex_box($position,$position_two) {
    display: flex;
    align-items: $position;
    justify-content: $position_two;
}

@mixin optional-at-root($sel) {
    @at-root #{if(not &, $sel, selector-append(&, $sel))} {
        @content;
    }
}

@mixin placeholder {
    @include optional-at-root('::-webkit-input-placeholder') {
        @content;
    }

    @include optional-at-root(':-moz-placeholder') {
        @content;
    }

    @include optional-at-root('::-moz-placeholder') {
        @content;
    }

    @include optional-at-root(':-ms-input-placeholder') {
        @content;
    }
}

@mixin media_query($min_width) {
    @media only screen and (min-width: $min_width) {
        @content
    }
}

@mixin media_query_inverse($max_width) {
    @media only screen and (max-width: $max_width) {
        @content
    }
}